package ninja.thefirearchmage.games.fourtykcalculator;

import lombok.Getter;

import java.util.Optional;

public class Weapon {
    @Getter
    private String name;
    @Getter
    private int strength;
    @Getter
    private int ap;
    @Getter
    private int attacks;
    @Getter
    private WeaponDamage averageDamage;
    @Getter
    private WeaponRangeType rangeType;
    @Getter
    private int hitValue;
    private boolean hasLethalHits;
    @Getter
    private Optional<Integer> sustainedHits;
    private boolean hasMortalWounds;
    private boolean hasHazardous;
    @Getter
    private Optional<Integer> antiInfantery;
    @Getter
    private Optional<Integer> antiVehicle;
    @Getter
    private Optional<Integer> antiMonster;
    @Getter
    private Optional<Integer> antiPsychic;
    private boolean hasHeavy;
    private boolean hasBlast;
    private boolean hasLance;
    private boolean ignoresCover;
    private boolean hasIndirectFire;
    @Getter
    private Optional<Integer> melta;
    @Getter
    private Optional<Integer> rapidFire;

    public boolean hasLethalHits() {
        return hasLethalHits;
    }

    public boolean hasMortalWounds() {
        return hasMortalWounds;
    }

    public boolean hasHazardous() {
        return hasHazardous;
    }

    public boolean isHeavy() {
        return hasHeavy;
    }

    public boolean hasBlast() {
        return hasBlast;
    }

    public boolean ignoresCover() {
        return ignoresCover;
    }

    public boolean hasLance() {
        return hasLance;
    }
    public boolean hasIndirectFire() {
        return hasIndirectFire;
    }
}
